/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
XaLib.include("chrome://xalib/content/UI/Controls.js");
XaLib.include("chrome://xalib/content/RDF/RDF.js");
XaLib.include("chrome://xalib/content/RDF/FactStore.js");
XaLib.include("chrome://xalib/content/IO/File/Directory.js");
XaLib.include("chrome://xalib/content/DOM/DOMLoader.js");
XaLib.include("chrome://xalib/content/RDF/SPARQL/Query.js");
XaLib.include("chrome://xalib/content/FilePicker/FilePicker.js");
XaLib.include("chrome://xalib/content/JSON/JSON.js");

const MOSTRECENTFILES_MAX = 10;
const MOSTRECENTFILES_SEP = 0x07; // BEL


const PREDEFINED_TEST_DIR = "chrome://testsparql/content/Tests/"
const SPARQL_DIR = "chrome://testsparql/content/"
const NEW_QUERY_NAME = "New Query.xml";

var controls;

var queryDirURI;
var queryDir;

var treeResultsView;

var queryDoc;
var newQueryItem;
var selectedItemName; 

function OnLoad(event) {
	controls = Controls.init();
	treeResultsView = new TreeResultsView(controls.treeResults);
	controls.treeResults.treeBoxObject.view = treeResultsView;
	
	controls.lblQueries.setAttribute("hidden", "true");
	controls.queries.setAttribute("hidden", "true");
	controls.btnRun.setAttribute("hidden", "true");
	controls.btnNew.setAttribute("hidden", "true");
	controls.btnSave.setAttribute("hidden", "true");
	controls.btnSaveAs.setAttribute("hidden", "true");
}
function addMostRecentFiles(directoryURI, remove) {
	var mrf = controls.window.getAttribute("mostRecentFiles"); // Persisted file list.
	// Build new.
	var mrfArray = mrf.split(MOSTRECENTFILES_SEP); // entries delimited by a new line.
	// remove the file if it is already in the list;
	for (var i=0; i < mrfArray.length; i++) {
		if (mrfArray[i] == directoryURI) {
			mrfArray.splice(i,1);
			break;
		}
	}
	// Add new entry and prune list to max length.
	if (!remove) {
		mrfArray.unshift(directoryURI);
		while (mrfArray.length > MOSTRECENTFILES_MAX) 
			mrfArray.pop();
	}	
	controls.window.setAttribute("mostRecentFiles", mrfArray.join(MOSTRECENTFILES_SEP));
}

function buildMostRecentFiles() {
	var mrfStart = controls.mrf_start;
	// remove old elements.
	while (mrfStart.nextSibling)
		mrfStart.parentNode.removeChild(mrfStart.nextSibling);

	var mrf = controls.window.getAttribute("mostRecentFiles"); // Persisted file list.
	// Build new.	
	var mrfArray = mrf.split(MOSTRECENTFILES_SEP); // entries delimited by a new line.
	mrf = "";
	var sep = "";
	for (var i=0; i < mrfArray.length; i++) {
		var directoryURI = mrfArray[i];
		if (!directoryURI)
			continue;
		var dir = new File(directoryURI);
		if (!dir.exists()) 
			continue;
		mrf += sep + directoryURI;
		sep = MOSTRECENTFILES_SEP;	
		var menuitem = document.createElement("menuitem");
		var directoryPath = File.URLToPath(directoryURI);
		menuitem.setAttribute("label",(i+1) + ". " + directoryPath);
		if (directoryURI.indexOf('"') == -1) { // Too bad file name contains a quote.
			menuitem.setAttribute("oncommand", 'cmdMrfDir("' + directoryURI + '")');
			controls.selDirPopup.appendChild(menuitem);
		}
		controls.window.setAttribute("mostRecentFiles", mrf);
	}
}

function cmdPredefined(event) {
	queryDirURI = PREDEFINED_TEST_DIR;
	buildPredefinedQueries(queryDirURI);
	controls.lblQueries.removeAttribute("hidden");
	controls.queries.removeAttribute("hidden");
	controls.btnRun.removeAttribute("hidden");
	controls.btnNew.setAttribute("hidden", "true");
	controls.btnSave.setAttribute("hidden", "true");
	controls.btnSaveAs.setAttribute("hidden", "true");
}

function cmdSelDir(event) {
	var filePicker = new FilePicker(window, "Open query directory.", FilePicker.OPEN_FOLDER);
	filePicker.setFilterMask(FilePicker.XML | FilePicker.ALL); 
	filePicker.filterIndex = 1;
	if (queryDir)
		filePicker.initialDirectory = queryDir;
	var result = filePicker.show();
	if (result == FilePicker.OK ) {
		queryDir = filePicker.file;
		if (!(queryDir.exists()))
			return;
		queryDirURI = queryDir.URL;
		if (!queryDirURI.endsWith("/"))
			queryDirURI += "/";
		buildPredefinedQueries(queryDirURI);
		controls.lblQueries.removeAttribute("hidden");
		controls.queries.removeAttribute("hidden");
		controls.btnRun.removeAttribute("hidden");
		controls.btnNew.removeAttribute("hidden");
		controls.btnSave.removeAttribute("hidden");
		controls.btnSaveAs.removeAttribute("hidden");
		addMostRecentFiles(queryDirURI, false);
	}
}

function cmdMrfDir(selDirectoryURI) {
	var aQueryDir = new File(selDirectoryURI);
	if (aQueryDir.exists()) {
		queryDir = aQueryDir;
		queryDirURI = queryDir.URL;	
		if (!queryDirURI.endsWith("/"))
			queryDirURI += "/";
		buildPredefinedQueries(queryDirURI);
		controls.lblQueries.removeAttribute("hidden");
		controls.queries.removeAttribute("hidden");
		controls.btnRun.removeAttribute("hidden");
		controls.btnNew.removeAttribute("hidden");
		controls.btnSave.removeAttribute("hidden");
		controls.btnSaveAs.removeAttribute("hidden");
	}
	else {
		alert("Directory " + selDirectoryURI + " not found.");
		addMostRecentFiles(selDirectoryURI, true);
	}
}

function buildPredefinedQueries(queryDirURI) {
	var popup = controls.queriesPopup;
	while (popup.firstChild) {
		popup.removeChild(popup.firstChild);
	}
	newQueryItem = document.createElement("menuitem");
		newQueryItem.setAttribute("label", NEW_QUERY_NAME);
	popup.appendChild(newQueryItem);
	controls.queries.selectedItem = newQueryItem;

	queryDir = new File(queryDirURI);
	var itr = queryDir.files(/.xml$/);
	var aTest;

	while ( (aTest = itr()) ) {
		var menuitem = document.createElement("menuitem");
			menuitem.setAttribute("label", aTest.leaf);
			if (selectedItemName && aTest.leaf == selectedItemName)
				controls.queries.selectedItem = menuitem;
		popup.appendChild(menuitem);
	}
}

function cmdQuerySelected(event) {
	var menuitem = event.target;
	if (menuitem.localName != "menuitem")
		return;
	clearResults();		
	selectedItemName = menuitem.getAttribute("label");
	queryDoc = DOMLoader.load("text/xml", queryDirURI + selectedItemName, true);

	var queryElem = queryDoc.getElementsByTagName("query")[0];
	if (!queryElem) {
		alert("Selected item is not a saved query.");
		controls.btnRun.setAttribute("hidden","true");
		return;
	}
	controls.btnRun.removeAttribute("hidden");
	controls.txtQuery.value = queryElem.firstChild.nodeValue;
}

function cmdNew(event) {
	clearResults();		
	controls.queries.selectedItem = newQueryItem;
	selectedItemName = newQueryItem.getAttribute("label");
	queryDoc = DOMLoader.load("text/xml", SPARQL_DIR + selectedItemName, true);
}
function cmdSave(event) {
	var selectedItem = controls.queries.selectedItem;
	if (controls.queries.selectedItem == newQueryItem)
		cmdSaveAs(event);
	else 
		SaveInternal(selectedItem.getAttribute("label"));
}

function cmdSaveAs(event) {
	var selectedItem = controls.queries.selectedItem;
	var filePicker = new FilePicker(window, "Save As SPARQL query.", FilePicker.SAVE);
	filePicker.setFilterMask(FilePicker.XML | FilePicker.ALL); 
	filePicker.filterIndex = 1;
	filePicker.initialDirectory = queryDir;
	var leafName = selectedItem.getAttribute("label")
	if (leafName != NEW_QUERY_NAME)
		filePicker.initialFilename = leafName;
	var result = filePicker.show();
	if (result == FilePicker.OK || result == FilePicker.OK_REPLACE ) {
		leafName = filePicker.file.leaf;
		if (leafName == NEW_QUERY_NAME)
			alert("Can't save query with name:" + NEW_QUERY_NAME);
		else			
			SaveInternal(leafName);
	}
}
function SaveInternal(leafName) {
	if (!leafName.endsWith(".xml"))
		leafName += ".xml";
	var queryElem = queryDoc.getElementsByTagName("query")[0];
	while (queryElem.firstChild)
		queryElem.removeChild(queryElem.firstChild);
	var CData = document.createCDATASection(controls.txtQuery.value);
	queryElem.appendChild(CData);
	

	var resultsArray = treeResultsView.getResultsArray();
	if (resultsArray) { // query has been run.
		var resultsElem = queryDoc.getElementsByTagName("results")[0];
		if (!resultsElem) {
			resultsElem = document.createElement("results");
			document.documentElement.appendChild(resultsElem);
		}
		while (resultsElem.firstChild)
			resultsElem.removeChild(resultsElem.firstChild);
		CData = document.createCDATASection(JSON.toJSON(resultsArray));
		resultsElem.appendChild(CData);
	}
	
	domSerializer = new XMLSerializer();
	var content = domSerializer.serializeToString( queryDoc );
	var out = queryDir.append(leafName);
	out.open(File.WRITE);
	out.write(content);
	out.close();
	
	selectedItemName = leafName;
	buildPredefinedQueries(queryDirURI);
}

function cmdRun(event) {

	clearResults();

	try {
		var q;
		eval(controls.txtQuery.value);
	}
	catch (e) {
		var msg = e.toString();
		displayError("Query Syntax Error:", msg);
		return;
	}
	try {
		q.startTime = new Date();
		q.compile();
		q.execute();
		q.endTime = new Date();
	}
	catch (e) {
		var msg = e.toString();
		displayError("Internal Execution Error:", msg);
		return;
	}

	treeResultsView.initColumns(q.spec.Select);
	displayResults(q);
	q = null;
	
}
function clearResults() {
	controls.txtStatus.value = "";
	treeResultsView.clearResults();
	theQueryResults = null;
}
function displayError(title, msg) {
	controls.txtStatus.value = title + "\n" + msg;
}

function displayResults(query) {
	var time = (query.endTime.valueOf() - query.startTime.valueOf()) / 1000;
	if (time < .001)
		time = "< 1ms.";
	else
		time = time + " sec.";
	controls.txtStatus.value = "Count: " + query.resultsArray.length + "  Run Time: " + time;
	treeResultsView.displayResults(query.resultsArray);
}

function TreeResultsView(tree) {
	this._tree = tree;
	this._treecols = tree.getElementsByTagName("treecols")[0];
	this._results = [];
	this._sortArray = null;
}

TreeResultsView.prototype = {
	setTree: function(treeBoxObject) {},
	getResultsArray : function() { return this._results; },
  	get rowCount() {return this._results.length},
  	getImageSrc : function(row,column) {},
	getProgressMode : function(row,column) {},
  	getCellValue : function(row,column) {},
  	getCellText : function(row,column) {
  		if (this._sortArray)
  			row = this._sortArray[row].index;
  	  	var val = this._results[row][column];
    	return val;
  	},
  	isSeparator : function(index) { return false; },
  	isSorted : function() { return (this._SortArray != null); },
  	isContainer : function(index) { return false; },
  	cycleHeader : function(aColId, aElt) {},
  	getRowProperties : function(row,column,prop) {},
  	getColumnProperties : function(column,columnElement,prop) {},
  	getCellProperties : function(row,prop) {},
  	
  	initColumns : function (Select) {
  		// Assume no columns present.
		
		// Build a column for each query result variable.
		var needsSplitter = false;
		for (var i=0; i<Select.length; i++) {
			if (needsSplitter) {
				var splitter = document.createElement("splitter");
				splitter.setAttribute("class","tree-splitter");
				this._treecols.appendChild(splitter);
			}
			needsSplitter = true;
	
			var name = Select[i].name;
			var treecol = document.createElement("treecol");
				treecol.setAttribute("flex","1");
				treecol.setAttribute("id", name);			
				treecol.setAttribute("label", name);
				treecol.setAttribute("sortActive", "true");
				treecol.setAttribute("sortDirection", "natural");
				treecol.setAttribute("onclick", "treeResultsView.cmdSortColumn(this);");
			this._treecols.appendChild(treecol);
		}
		this._tree.setAttribute("hidecolumnpicker","false");

  	},
  	
  	clearResults : function() {
  		// remove column headings.
		var treecols = this._treecols;		
		while (treecols.firstChild) 
			treecols.removeChild(treecols.firstChild);
				
		this._tree.setAttribute("hidecolumnpicker","true");
		this._results = null;
		this._sortArray = null;
		this._tree.treeBoxObject.view = null;
  	},
  	
  	displayResults : function(resultsArray) {
  		this._results = resultsArray;
  		this._tree.treeBoxObject.view = this;
  	},
  	
  	cmdSortColumn : function(treecol) {
		var results = this._results;
		var column = treecol.getAttribute("id");
		if (treecol != this._prevSortCol) {
			// remove sort indicator from previous sort column.
			if (this._prevSortCol)
				this._prevSortCol.setAttribute("sortDirection","natural");
			this._prevSortCol = treecol;
		}
		
		var direction = treecol.getAttribute("sortDirection");
		var sortArray;
		if (direction == "descending") {
			direction = "natural";
			sortArray = null;
		}
		else {
			sortArray = new Array(results.length);
			for (var i=0; i<sortArray.length; i++) {
				var val = new String(results[i][column]);
				val.index = i; // Tag entry with results index.
				sortArray[i] = val;
			}
			sortArray.sort();
			if (direction == "ascending") {
				direction = "descending";
				sortArray.reverse();
			}
			else {
				direction = "ascending";
			}
		}
		treecol.setAttribute("sortDirection", direction);
		this._sortArray = sortArray;
		this._tree.treeBoxObject.invalidate();
	},
 };
 
